#############################################################
#
#   Program: cum_inc.R
#   Project: 
# 
#   PI: 
#   Statistician: Bryan Shephard, PhD
#   Biostatistician/Programmer: Meridith Blevins, MS
#   Purpose: 
#   Created: 31 January 2013
#   Revisions: 17 February 2015 - reused for Mobile Clinic data
#              16 July 2015 - reused for Nigeria PMTCT data
#              1 April 2016 - reused for IeDEA TB analysis
#     
#
#############################################################

library(cmprsk)



getltfucmprsk <- function(incevent,time,subset=TRUE){
  I <- cuminc(time[subset],incevent[subset])
  Ionly <- list(x=I$"1 1"$time,y=I$"1 1"$est)
  return(list(incplot=Ionly,inc=I,event=incevent,time=time))
}
testltfucmprsk <- function(incevent,time,group){
  I <- cuminc(time,incevent,group=group)
  Ionly <- list(x=I$"1 1"$time,y=I$"1 1"$est)
  return(list(incplot=Ionly,inc=I,event=incevent,time=time))
}
getcumincest <- function(itime,inc,alpha=0.05,col2=FALSE){
    ## Aalen's variance estimator -- Delta method
    ## CI is based on 1-F(t) = S
    ## (S)^exp(+-A)
    ## A=zalpha*sqrt(Var(S) / (S*logS)
       attime=timepoints(inc$inc,times=itime)
       est=1-attime$est[1,]
       se=sqrt(attime$var[1,])
       zalpha=qnorm(1-alpha/2)
       A=zalpha*se/(est*log(est))
      L1=est^(exp(A))
      L2=est^(exp(-A))
    inc.sum1 <- paste(paste(itime,"days"),paste(sapply(1-est,myper2)," (",sapply(1-L1,myper2),", ",sapply(1-L2,myper2),")",sep=""),sep=" & ")
    if(col2){inc.sum1 <- paste(paste(sapply(1-est,myper2)," (",sapply(1-L1,myper2),", ",sapply(1-L2,myper2),")",sep=""),sep=" & ")}
    return(inc.sum1)
}
myper2 <- function(x){
    # y <- paste(format(round(100*x,1),nsmall=1),"\\%",sep="")
    y <- paste(round(100*x),"\\%",sep="")
    return(y)
}
library(RColorBrewer)
mypalette <- brewer.pal(3, "Set1") ## rainbow(3,start=0,end=.89)




