

## LTFU during the first year after RST
d2$ltfu540 <- ifelse(d2$rst2ltfu<=540 & d2$rst2close - d2$rst2ltfu >= 540 & d2$rst2close>=540,1,0) 
d2$ltfu540[!is.na(d2$rst2tfer) & d2$rst2tfer<=d2$rst2ltfu] <- 0 ## remove transfers from this
d2$ltfu540 <- ifelse(d2$ltfu540==1,"Yes","No")
d2$death540 <- ifelse(!is.na(d2$rst2death) & d2$rst2death<=540,1,0)
d2$death540 <- ifelse(d2$death540==1,"Yes","No")

dfout <- merge(data[,!(names(data) %in% "male")],d2[c("patient","ltfu540","death540")],all.x=TRUE)

dfout$rst2vf <- as.Date(dfout$vf_d) - dfout$rst_d
dfout$vfailure540 <- ifelse(dfout$vfailure == 1 & dfout$rst2vf<=540,1,0)
dfout$vfailure540 <- ifelse(dfout$vfailure540==1,"Yes","No")


printtable2 <- function(byvar,dd,inc.pval=TRUE,excludeline=NULL){
  line1 <- tail(getnptex(var=dd$retained2015,by=byvar,label="Retained in care for 1 year",inc.pval=inc.pval),1)
  line2 <- tail(getnptex(var=dd$ltfu540,by=byvar,label="LTFU in 18 months",inc.pval=inc.pval),1)
  line3 <- tail(getnptex(var=dd$vfailure540,by=byvar,label="Virologic Failure in 18 months",inc.pval=inc.pval),1)
  line4 <- tail(getnptex(var=dd$death540,by=byvar,label="Death in 18 months",inc.pval=inc.pval),1)

  table1 <- paste(sapply(paste0("line",setdiff(1:4,excludeline)),get,envir=environment()),collapse=" \\\\ ")
  table1head <- printheader(table(byvar),pval=inc.pval)
  return(list(table=table1,header=table1head))
}
t3 <- printtable2(byvar=dfout$su,dd=dfout)
